//This script handles the objects added by the plugin. This includes the networking for many of the
//new buildings as well as clientside input for the build menu.
globalvar possessive;
possessive = "'s" //I need this because I can't write apostrophes.

object_event_add(BlindingFlash, ev_create, 0, '
alarm[0] = 30 / global.delta_factor;
')
object_event_add(BlindingFlash, ev_alarm, 0, '
instance_destroy();
')
object_event_add(BlindingFlash, ev_draw, 0, '
draw_set_alpha(alarm[0]/(30/global.delta_factor));
draw_rectangle_color(view_xview[0],view_yview[0],view_xview[0]+view_wview[0],view_yview[0]+view_hview[0],c_white,c_white,c_white,c_white,0);
')
object_event_clear(SentryHealthHud,ev_draw,0);
object_event_add(SentryHealthHud,ev_draw,0,'
if(global.myself.object == -1 or global.myself.class != CLASS_ENGINEER)
{
    instance_destroy();
    exit; 
}
var offset;
offset = 145;
//Draw building HUDs, prioritizing in the order of Sentry, Dispenser, Teleporter Entrance, Teleporter Exit.
if (global.myself.sentry)
{
    drawHealth(45, view_hview[0]-(offset-22), global.myself.sentry.hp, global.myself.sentry.maxHp);
    draw_sprite_ext(sprite_index, global.myself.team, view_xview[0]+5, view_yview[0]+view_hview[0]-offset, 2, 2, 0, c_white, 1);
	offset += 70;
}

if (global.myself.dispenser)
{
    drawHealth(45, view_hview[0]-(offset-22), global.myself.dispenser.hp, global.myself.dispenser.maxHp);
    draw_sprite_ext(sprite_index, 2+global.myself.team, view_xview[0]+5, view_yview[0]+view_hview[0]-offset, 2, 2, 0, c_white, 1);
	offset += 70;
}
if (global.myself.tentrance)
{
    drawHealth(45, view_hview[0]-(offset-22), global.myself.tentrance.hp, global.myself.tentrance.maxHp);
    draw_sprite_ext(sprite_index, 4+global.myself.team, view_xview[0]+5, view_yview[0]+view_hview[0]-offset, 2, 2, 0, c_white, 1);
	offset += 70;
}
if (global.myself.texit)
{
    drawHealth(45, view_hview[0]-(offset-22), global.myself.texit.hp, global.myself.texit.maxHp);
    draw_sprite_ext(sprite_index, 6+global.myself.team, view_xview[0]+5, view_yview[0]+view_hview[0]-offset, 2, 2, 0, c_white, 1);
	offset += 70;
}
')
object_event_add(Character,ev_create,0,'
	teleporter = noone;
')

object_event_add(Character,ev_step,ev_step_begin,'
	if teleporter = noone exit;
	
	if instance_exists(teleporter) {
	    if instance_exists(teleporter.ownerPlayer.texit) {
		    if !(collision_circle(x, y, 20, teleporter, false, true) < 0) && !intel {
			    if (pressedKeys | keyState) & $02 && teleporter.charge == 100 && teleporter.ownerPlayer.texit.built {
				    x = teleporter.ownerPlayer.texit.x;
				    y = teleporter.ownerPlayer.texit.y-10;
				    teleporter.charge = 0;
				    teleporter = noone;					
					if player = global.myself {
					    with BlindingFlash instance_destroy();
    					instance_create(0,0,BlindingFlash);
					}
			    }
		    } else teleporter = noone;
	    } else teleporter = noone;
	}
');

object_event_clear(Character,ev_collision,SentryGibs);
object_event_add(Character,ev_collision,SentryGibs,'
//Alter SentryGibs so that you get 25 from tele gibs.
if player.class == CLASS_ENGINEER && nutsNBolts < maxNutsNBolts {
    with other instance_destroy();
    nutsNBolts += 50*other.power;
    playsound(x,y,PickupSnd);
}
')
object_event_add(SentryGibs,ev_create,0,'
power = 1;
')
//I would like to apologize for clearing this event so that I can change ONE FUCKING LINE.
//There is, however, no other way to do this.
object_event_clear(PlayerControl,ev_step,ev_step_begin);
object_event_add(PlayerControl,ev_step,ev_step_begin,'
if(instance_exists(MenuController))
    exit;
    
var kickOpen;
kickOpen = false
if (instance_exists(ScoreTableController))
    if (ScoreTableController.showadmin)
        kickOpen = true;
    
if(instance_exists(TeamSelectController) || instance_exists(ClassSelectController) || kickOpen)
    menuOpen = true;
else
    menuOpen = false;

//Checking for input - Mapped Keys
if(keyboard_check_pressed(global.changeTeam))
    inputChangeTeam();
if(keyboard_check_pressed(global.changeClass))
    inputChangeClass();

event_user(8);
    
var keybyte;
keybyte = 0;

//character object exists
if(global.myself.object != -1)
{
    if(!menuOpen)
    {
        if(keyboard_check(global.left)) keybyte |= $40;
        if(keyboard_check(global.right)) keybyte |= $20;
        if(keyboard_check(global.jump)) keybyte |= $80;
        if(keyboard_check(global.down)) keybyte |= $02;
        if(keyboard_check_pressed(global.medic)) keybyte |= $04;
        if(keyboard_check_pressed(global.chat1)) inputChat1();
        if(keyboard_check_pressed(global.chat2)) inputChat2();
        if(keyboard_check_pressed(global.chat3)) inputChat3();
        if(keyboard_check_pressed(global.drop)) inputDrop();
        
        if(!global.myself.humiliated)
        {
            if(keyboard_check(global.attack)) keybyte |= $10;
            if(keyboard_check(global.special)) keybyte |= $08;
            if(keyboard_check_pressed(global.special)) execute_string(inputSpecialx);
            if(keyboard_check_pressed(global.taunt))
            {
                keybyte |= $01;
                inputTaunt();
            }
            if(mouse_check_button(mb_left))
            {
                if(global.attack == MOUSE_LEFT) keybyte |= $10;
                if(global.special == MOUSE_LEFT) keybyte |= $08;
            }
            if(mouse_check_button_pressed(mb_left) and global.special == MOUSE_LEFT)
                execute_string(inputSpecialx);
            if(mouse_check_button(mb_right))
            {
                if(global.attack == MOUSE_RIGHT) keybyte |= $10;
                if(global.special == MOUSE_RIGHT) keybyte |= $08;
            }
            if(mouse_check_button_pressed(mb_right) and global.special == MOUSE_RIGHT)
                execute_string(inputSpecialx);
            
        }
    }
    
    if(global.run_virtual_ticks or keyboard_check_pressed(global.taunt))
        ClientInputstate(global.serverSocket, keybyte);
    socket_send(global.serverSocket);
}
// spectator controls
else if (instance_exists(Spectator))
{
    if(!menuOpen)
    {
        if(mouse_check_button_pressed(mb_left))
            with (Spectator) event_user(7);
        if(mouse_check_button_pressed(mb_right))
            with (Spectator) event_user(8);
    }
}

if(keybyte != 0
        or keyboard_check(global.left)
        or keyboard_check(global.right)
        or keyboard_check(global.jump)
        or keyboard_check(global.down)) {
    afktimer = afktimeout;
}

')

object_event_add(BuildMenu,ev_create,0,'
	_x = mouse_x-view_xview[0];
	_y = mouse_y-view_yview[0];
	q = -1;

	alpha=0.02;
	done = false;
	flash = 0;
');

//This was a rather fun bit to write. Basically, it checks the distance
//of the cursor from the effective origin of the circle, moves the origin
//if that distance is greater than 25, and then sets the quadrant depending
//on the angle of the cursor relative to the origin.

//Basically, this makes the menu work. Don't fuck with it too much.

object_event_add(BuildMenu,ev_step,ev_step_begin,'
	if done exit;

	var rel_mousex,rel_mousey, lastq;
	rel_mousex = mouse_x-view_xview[0];
	rel_mousey = mouse_y-view_yview[0];

	lastq = q;

	if (point_distance(_x,_y,rel_mousex,rel_mousey) < 25) {
		if lastq =-1 q = -1;
	} else {
		q = round((point_direction(_x,_y,rel_mousex,rel_mousey))/90);
		_x+=((rel_mousex-_x)*global.delta_factor)/15
		_y+=((rel_mousey-_y)*global.delta_factor)/15
	}

	if (point_distance(_x,_y,rel_mousex,rel_mousey) > 20) && q = -1{
		q = round((point_direction(_x,_y,rel_mousex,rel_mousey))/90);
	}
	if (point_distance(_x,_y,rel_mousex,rel_mousey) <= 20){
		q = -1;
	}

	while q >= 4 {
	q -= 4;
	}
');

object_event_add(BuildMenu,ev_step,ev_step_normal,'
	if (!done and alpha < 1)
		alpha = min(1, power(alpha,power(0.5, global.delta_factor))+0.05);
	else if (done and alpha > 0)
		alpha = max(0, power(alpha,power(2, global.delta_factor))-0.05);
	else if (done and alpha < 1/256)
		instance_destroy();

	if done flash = !flash;

	if ((instance_exists(TeamSelectController) || instance_exists(ClassSelectController)|| !instance_exists(global.myself.object) || global.myself.class != CLASS_ENGINEER) && !done) {
		q = -1;
	   done = true;
	}
');
//This event handles sending things to the server.
object_event_add(BuildMenu,ev_mouse,ev_global_right_release,'
	if q == -1 done = true;
	
	if done exit;
	
	var sendBuffer, _player;
	_player = global.myself;
	
	var cost, str, obj;
	switch q {
	    case 0:
			cost = 50;
			str = "texit"
			obj = TeleporterExit
		break;
		case 1:
			cost = 100;
			str = "sentry"
			obj = Sentry
			
		break;
		case 2:
			cost = 50;
			str = "tentrance"
			obj = TeleporterEntrance
		break;
		case 3:
			cost = 100;
			str = "dispenser"
			obj = Dispenser
		break;
	}
	
	sendBuffer = buffer_create();
			if !global.isHost {
			    var chk;
			    with _player chk = variable_local_get(str);
					if chk == noone {
						if !(collision_circle(_player.object.x, _player.object.y, 50, Sentry, false, true) < 0 and collision_circle(_player.object.x, _player.object.y, 50, Dispenser, false, true) < 0 and collision_circle(_player.object.x, _player.object.y, 50, TeleporterEntrance, false, true) < 0 and collision_circle(_player.object.x, _player.object.y, 50, TeleporterExit, false, true) < 0) {
							with(NoticeO) instance_destroy();
							instance_create(0,0,NoticeO);
							with NoticeO notice = NOTICE_TOOCLOSE;
						} else if _player.object.nutsNBolts < cost {
							with(NoticeO) instance_destroy();
							instance_create(0,0,NoticeO);
							with NoticeO notice = NOTICE_NUTSNBOLTS;
						} else if !_player.object.onCabinet and (collision_point(_player.object.x,_player.object.y,SpawnRoom,0,0) < 0) {
								write_ubyte(sendBuffer, buildings.request);
								write_ubyte(sendBuffer, q);
								write_ubyte(sendBuffer, 1);
									
								write_ushort(sendBuffer, round(_player.object.x*5));
								write_ushort(sendBuffer, round(_player.object.y*5));
								PluginPacketSend(buildings.packetID,sendBuffer);
						}
					} else {
					    write_ubyte(sendBuffer, buildings.request);
						write_ubyte(sendBuffer, q);
						write_ubyte(sendBuffer, 0);
						PluginPacketSend(buildings.packetID,sendBuffer);
					}
			} else {
			    var chk;
			    with _player chk = variable_local_get(str);
				if(_player.object != -1) {
					if chk == noone {
						if(_player.class == CLASS_ENGINEER) {
							if !(collision_circle(_player.object.x, _player.object.y, 50, Sentry, false, true) < 0 and collision_circle(_player.object.x, _player.object.y, 50, Dispenser, false, true) < 0 and collision_circle(_player.object.x, _player.object.y, 50, TeleporterEntrance, false, true) < 0 and collision_circle(_player.object.x, _player.object.y, 50, TeleporterExit, false, true) < 0) {
							    with(NoticeO) instance_destroy();
			                    instance_create(0,0,NoticeO);
					            with NoticeO notice = NOTICE_TOOCLOSE;
                            } else if _player.object.nutsNBolts < cost {
					            with(NoticeO) instance_destroy();
			                    instance_create(0,0,NoticeO);
					            with NoticeO notice = NOTICE_NUTSNBOLTS;
				            } else if !_player.object.onCabinet and (collision_point(_player.object.x,_player.object.y,SpawnRoom,0,0) < 0) {
							    write_ubyte(sendBuffer, buildings.request);
							    write_ubyte(sendBuffer, q);
							    write_ubyte(sendBuffer, ds_list_find_index(global.players,_player));
							    write_ubyte(sendBuffer, 1);
							
							    write_ushort(sendBuffer, round(_player.object.x*5));
							    write_ushort(sendBuffer, round(_player.object.y*5));
							
							    execute_file(buildBuilding,_player, _player.object.x, _player.object.y, obj, str, cost, _player.object.image_xscale);
							    PluginPacketSend(buildings.packetID,sendBuffer);
						    }
						}
					} else {
						if(_player.class == CLASS_ENGINEER) {
							write_ubyte(sendBuffer, buildings.request);
							write_ubyte(sendBuffer, ds_list_find_index(global.players,_player));
							write_ubyte(sendBuffer, 0);
							write_ubyte(sendBuffer, q);
							
							with chk instance_destroy();
							PluginPacketSend(buildings.packetID,sendBuffer);
						}
					}
				}
			}
	PluginPacketPop(buildings.packetID);
	
	done = true;
');

//This next one's pretty long. It handles the drawing of the build menu, obviously.
object_event_add(BuildMenu,ev_draw,0,'
	var xoffset,yoffset,xsize,ysize;

	xoffset = view_xview[0];
	yoffset = view_yview[0];
	xsize = view_wview[0];
	ysize = view_hview[0];
	
	//Draw the outline.
	draw_sprite_ext(BuildMenuS,0,xoffset+xsize/2,yoffset+ysize/2,image_xscale,image_yscale,0,c_white,alpha);

	//Draw the back of the menu. "q" is the quadrant selected, defined in BeginStep.
	var i;

	for (i=-1;i<=3;i+=1){
		if i!=q draw_sprite_ext(BuildMenuS,i+2,xoffset+xsize/2,yoffset+ysize/2,image_xscale,image_yscale,0,c_white,alpha);
		else draw_sprite_ext(BuildMenuS,i+2+(5*!flash),xoffset+xsize/2,yoffset+ysize/2,image_xscale,image_yscale,0,c_white,alpha);
	}

	//Draw the icons on the outside of the circle.
	draw_sprite_ext(BuildMenuS,11+global.myself.team,xoffset+xsize/2,yoffset+ysize/2,image_xscale,image_yscale,0,c_white,alpha);

	if global.myself.sentry != noone draw_sprite_ext(BuildMenuS,35+(4*global.myself.team),xoffset+xsize/2,yoffset+ysize/2,image_xscale,image_yscale,0,c_white,alpha);
	else if global.myself.object.nutsNBolts < 100 draw_sprite_ext(BuildMenuS,31,xoffset+xsize/2,yoffset+ysize/2,image_xscale,image_yscale,0,c_white,alpha);
	
	if global.myself.dispenser != noone draw_sprite_ext(BuildMenuS,37+(4*global.myself.team),xoffset+xsize/2,yoffset+ysize/2,image_xscale,image_yscale,0,c_white,alpha);
	else if global.myself.object.nutsNBolts < 100 draw_sprite_ext(BuildMenuS,33,xoffset+xsize/2,yoffset+ysize/2,image_xscale,image_yscale,0,c_white,alpha);
	
	if global.myself.texit != noone draw_sprite_ext(BuildMenuS,34+(4*global.myself.team),xoffset+xsize/2,yoffset+ysize/2,image_xscale,image_yscale,0,c_white,alpha);
	else if global.myself.object.nutsNBolts < 50 draw_sprite_ext(BuildMenuS,30,xoffset+xsize/2,yoffset+ysize/2,image_xscale,image_yscale,0,c_white,alpha);
	
	if global.myself.tentrance != noone draw_sprite_ext(BuildMenuS,36+(4*global.myself.team),xoffset+xsize/2,yoffset+ysize/2,image_xscale,image_yscale,0,c_white,alpha);
	else if global.myself.object.nutsNBolts < 50 draw_sprite_ext(BuildMenuS,32,xoffset+xsize/2,yoffset+ysize/2,image_xscale,image_yscale,0,c_white,alpha);

	//Draw the icon on the inside of the circle.
	switch q {
		case 0 :
			if global.myself.texit != noone draw_sprite_ext(BuildMenuS,18+(8*global.myself.team),xoffset+xsize/2,yoffset+ysize/2,image_xscale,image_yscale,0,c_white,alpha);
			else if global.myself.object.nutsNBolts >= 50 draw_sprite_ext(BuildMenuS,14+(12*global.myself.team),xoffset+xsize/2,yoffset+ysize/2,image_xscale,image_yscale,0,c_white,alpha);
			else draw_sprite_ext(BuildMenuS,13,xoffset+xsize/2,yoffset+ysize/2,image_xscale,image_yscale,0,c_white,alpha);
		break;
		case 1 :
			if global.myself.sentry != noone draw_sprite_ext(BuildMenuS,19+(8*global.myself.team),xoffset+xsize/2,yoffset+ysize/2,image_xscale,image_yscale,0,c_white,alpha);
			else if global.myself.object.nutsNBolts >= 100 draw_sprite_ext(BuildMenuS,15+(12*global.myself.team),xoffset+xsize/2,yoffset+ysize/2,image_xscale,image_yscale,0,c_white,alpha);
			else draw_sprite_ext(BuildMenuS,13,xoffset+xsize/2,yoffset+ysize/2,image_xscale,image_yscale,0,c_white,alpha);
		break;
		case 2 :
			if global.myself.tentrance != noone draw_sprite_ext(BuildMenuS,20+(8*global.myself.team),xoffset+xsize/2,yoffset+ysize/2,image_xscale,image_yscale,0,c_white,alpha);
			else if global.myself.object.nutsNBolts >= 50 draw_sprite_ext(BuildMenuS,16+(12*global.myself.team),xoffset+xsize/2,yoffset+ysize/2,image_xscale,image_yscale,0,c_white,alpha);
			else draw_sprite_ext(BuildMenuS,13,xoffset+xsize/2,yoffset+ysize/2,image_xscale,image_yscale,0,c_white,alpha);
		break;
		case 3 :
			if global.myself.dispenser != noone draw_sprite_ext(BuildMenuS,21+(8*global.myself.team),xoffset+xsize/2,yoffset+ysize/2,image_xscale,image_yscale,0,c_white,alpha); 
			else if global.myself.object.nutsNBolts >= 100 draw_sprite_ext(BuildMenuS,17+(12*global.myself.team),xoffset+xsize/2,yoffset+ysize/2,image_xscale,image_yscale,0,c_white,alpha);
			else draw_sprite_ext(BuildMenuS,13,xoffset+xsize/2,yoffset+ysize/2,image_xscale,image_yscale,0,c_white,alpha);
		break;
		case -1:
			draw_sprite_ext(BuildMenuS,13,xoffset+xsize/2,yoffset+ysize/2,image_xscale,image_yscale,0,c_white,alpha);
		break;
	}
');

//Make it so sentries explode when they come in contact with other buildings.
object_event_add(Sentry,ev_step,ev_step_begin,'
if(global.isHost and (ownerPlayer.class != CLASS_ENGINEER or team != ownerPlayer.team or collision_circle(x,y+10,25,Sentry,false,true)>=0 or collision_circle(x,y+10,25,Dispenser,false,true)>=0 or collision_circle(x,y+10,25,TeleporterEntrance,false,true)>=0 or collision_circle(x,y+10,25,TeleporterExit,false,true)>=0))
{
    execute_file(sendEventBuildingDestruction, ownerPlayer, noone, noone, -1, 0);
	execute_file(doEventBuildingDestruction, ownerPlayer, noone, noone, -1, 0);
    exit;
}')

//Here we define the objects, Dispenser, TeleporterExit, and TeleporterEntrance. This lasts pretty much for the rest of the file.
object_event_add(Dispenser,ev_create,0,'
	image_speed = 0;
	vspeed = .001;
	oldVspeed = .001;
	maxHp = 100;
	hp = 25;
	built=0;
	image_speed = 0;
	landed=0;
	humiliated = 0;
	buildrate = 0.8;
	buildingtype = 1;
	ubered = 0;

	// For self-knockback when destroyed
	blastRadius = 65;
	knockback = 4;
	
    healTierHealth = 125;
    healTierAmount = 0.75;
    healedThisStep = false;
    healAmount = 1/3;
    hphealed = 0;
	healing = false;
    maxHealDistance = 100;
		   
	lastDamageDealer = noone;
	lastDamageSource = -1;
')
object_event_add(Dispenser,ev_step,ev_step_begin,'
if !instance_exists(ownerPlayer) {
    instance_destroy();
	exit;
}
if(global.isHost and (ownerPlayer.class != CLASS_ENGINEER or team != ownerPlayer.team or collision_circle(x,y+10,25,Sentry,false,true)>=0 or collision_circle(x,y+10,25,Dispenser,false,true)>=0 or collision_circle(x,y+10,25,TeleporterEntrance,false,true)>=0 or collision_circle(x,y+10,25,TeleporterExit,false,true)>=0))
{
    execute_file(sendEventBuildingDestruction, ownerPlayer, noone, noone, -1, buildingtype);
	execute_file(doEventBuildingDestruction, ownerPlayer, noone, noone, -1, buildingtype);
    exit;
}

if (built == 0 and vspeed == 0)
{
    if (hp < maxHp)
        hp += buildrate * global.delta_factor;
    else
        built = 1;
    buildrate = min(buildrate, buildrate+(0.4*global.delta_factor/45)); 
    image_index = floor((hp/maxHp)*18);
    if (landed == 0)
    {
        landed = 1;
        playsound(x,y,SentryFloorSnd);
        playsound(x,y,SentryBuildSnd);
    }  
} else if built image_index = 18;

if (humiliated == 1 and built == 1)
    event_user(1);
    
wallSetSolid();

// Try to get outside of the wallmask if we are in it.
if(!place_free(x, y))
    move_outside_solid(0, 6);
if(!place_free(x, y))
    move_outside_solid(180, 12);
if(!place_free(x, y))
{
    move_outside_solid(0, 6);
    move_outside_solid(90, 100);
}

if(place_free(x+hspeed, y+vspeed+0.6))
    vspeed += 0.6  * global.delta_factor;
if(!place_free(x+hspeed, y+vspeed) and place_free(x, y))
    event_user(2);

if(vspeed > 10)
    vspeed = 10;

wallUnsetSolid();

if(oldVspeed != 0 and vspeed == 0 and global.isHost)
{
	var sendBuffer;
	sendBuffer = buffer_create();
	write_ubyte(sendBuffer, buildings.building_position);
	write_ubyte(sendBuffer, buildingtype)
    write_ubyte(sendBuffer, ds_list_find_index(global.players, ownerPlayer));
    write_ushort(sendBuffer, round(x*5));
    write_ushort(sendBuffer, round(y*5));
	PluginPacketSend(buildings.packetID,sendBuffer);
}

oldVspeed = vspeed;

x += hspeed * global.delta_factor;
y += vspeed * global.delta_factor;
x -= hspeed;
y -= vspeed;

')
object_event_add(Dispenser,ev_step,ev_step_end,'
if !instance_exists(ownerPlayer) {
    instance_destroy();
	exit;
}
	if(global.isHost and hp<=0)
	{
		var healer;
		healer = noone;
		with(lastDamageDealer)
			if (object)
				if (object.healer)
					healer = object.healer;
					
		execute_file(sendEventBuildingDestruction, ownerPlayer, lastDamageDealer, healer, lastDamageSource, buildingtype);
	    execute_file(doEventBuildingDestruction, ownerPlayer, lastDamageDealer, healer, lastDamageSource, buildingtype);
		exit;
	}
	if(hp>maxHp) hp=maxHp;
')
object_event_add(Dispenser,ev_collision,KillBox,'
hp -= 999;
lastDamageDealer = noone;
')
object_event_add(Dispenser,ev_collision,FragBox,'
hp -= 999;
lastDamageDealer = noone;
')
object_event_add(Dispenser,ev_collision,IntelGate,'
hp -= 999;
lastDamageDealer = noone;
')
object_event_add(Dispenser,ev_step,ev_step_normal,'
if !instance_exists(ownerPlayer) {
    instance_destroy();
	exit;
}
var lasthealing;
lasthealing = healing;
if !built exit;
	with Player {
		if (object != -1 && object != noone && instance_exists(object)) {
		if ((team == other.team || class == CLASS_SPY) && !object.cloak) {
			with other {
				if(point_distance(x,y,other.object.x, other.object.y)<=maxHealDistance) {
					if(collision_line(x,y, other.object.x, other.object.y, Obstacle, true, true)<0) {
						healing = true;
						if (other.object.burnDuration > 0)
							other.object.burnDuration -= 1 * global.delta_factor;
						var healthGained;
						healthGained = healAmount * calculateHealingFactor(other.object.timeUnscathed);
						if(other.object.hp > healTierHealth)
							healthGained *= healTierAmount;
						other.object.hp = min(other.object.hp + healthGained * global.delta_factor, other.object.maxHp);
						if other.object.currentWeapon.alarm[5] > global.delta_factor*2 other.object.currentWeapon.alarm[5] = other.object.currentWeapon.alarm[5] - (other.object.currentWeapon.readyToShoot*(global.delta_factor/2))
						hphealed += healthGained * global.delta_factor;
						ownerPlayer.stats[HEALING] += healthGained * global.delta_factor;
						ownerPlayer.roundStats[HEALING] += healthGained * global.delta_factor;
						
						if hphealed >= HP_PER_POINT {
							ownerPlayer.stats[POINTS] += 1;
							ownerPlayer.roundStats[POINTS] += 1;
							hphealed -= HP_PER_POINT;
						}
						alarm[3] = 2 / global.delta_factor;
					}
				}
			
			
		if(alarm[3] <= 0) {
				healing = false;
		}
	
		if humiliated || !built healing = false;
		
		if !lasthealing and healing loopsoundstart(x,y,MedigunSnd);
		
		if healing loopsoundmaintain(x,y,MedigunSnd);
		
		if !healing loopsoundstop(MedigunSnd);
		}
	}
	}
}
')
object_event_add(Dispenser,ev_alarm,3,'
healing = false;
')
object_event_add(Dispenser,ev_other,ev_user1,'
    if built == 1 {
        image_index = 17;
    }
    humiliated = 1;
')
object_event_add(Dispenser,ev_other,ev_user2,'
{
    wallSetSolid();
    really_move_contact_solid(direction, speed);
    if(!place_free(x, y+1))
        vspeed = 0;
    wallUnsetSolid();
}
')
object_event_add(Dispenser,ev_draw,0,'
if(vspeed > 0)
{
    var chuteIndex;
    chuteIndex = ceil(vspeed/10*3)-1;
    image_index = chuteIndex + (team==TEAM_BLUE)*3;
    sprite_index = ParachuteSentry;
}
else
{
    if (team == TEAM_BLUE)
        sprite_index = DispenserBlueS;
    if (team == TEAM_RED)
        sprite_index = DispenserRedS;
}
xr = round(x);
yr = round(y);
var color;
if team = TEAM_RED color = c_red;
else if team = TEAM_BLUE color = c_blue;
	if built {
		with Player {
    		if instance_exists(object) {
	    		if ((team == other.team)) {
		    		with other if(point_distance(x,y,other.object.x, other.object.y)<=maxHealDistance) {
			    		if(collision_line(xr,yr, other.object.x, other.object.y, Obstacle, true, true)<0) {
				    			draw_set_alpha(0.3);
					    		draw_line_width_color(xr, yr, other.object.x, other.object.y, 5, color, color);	
					    }
					}
				}
			}
		}
	}
draw_set_alpha(1);
if global.myself.team == team draw_healthbar(xr-10, yr-30, xr+10, yr-25,hp*100/maxHp,c_black,c_red,c_green,0,true,true);
if (built && hp < .75 * maxHp) draw_sprite_part_ext(FlameS, random(4), 0, 0, 21, 9, xr-21/2, yr-10, 1, 1, c_white, 1 - (hp / maxHp));
draw_sprite_ext(sprite_index,image_index,xr,yr,image_xscale,image_yscale,image_angle,c_white,1);


if(distance_to_point(mouse_x, mouse_y)<25 && global.myself.team == team) {
    draw_set_alpha(1);   
    draw_set_halign(fa_center);
    draw_set_valign(fa_bottom); 
    if(team==TEAM_RED) {
        draw_set_color(c_red);
    } else {
        draw_set_color(c_blue);
    }
    draw_text(xr, yr-45, ownerPlayer.name + possessive);
    draw_text(xr, yr-35, "Provider");
}
')

object_event_add(Dispenser,ev_destroy,0,'
if !instance_exists(ownerPlayer) exit;
if (global.myself == ownerPlayer)
{
    if !instance_exists(NoticeO) instance_create(0,0,NoticeO);
    with NoticeO {
	notice = NOTICE_CUSTOM;
	message = "Provider scrapped!";
	}
}
loopsoundstop(MedigunSnd);

// Allow the mines stickied to this autogun to drop to the floor
with(Mine)
{
    if(place_meeting(x,y,other.id))
        stickied = false;
}

// Knock back our owner
with(ownerPlayer.object)
{
    if (distance_to_object(other) < other.blastRadius
        and !place_meeting(x, y+1, Obstacle))
    {
        var rdir, vectorfactor;
        rdir = point_direction(other.x, other.y, (bbox_left+bbox_right)/2, (bbox_top+bbox_bottom)/2);
        vectorfactor = point_distance(0, 0, power(sin(degtorad(rdir)), 2), power(cos(degtorad(rdir)), 2));
        if (1 - distance_to_object(other)/other.blastRadius <= 0.25)
            continue;
        motion_add(rdir, min(15, other.knockback-other.knockback*(distance_to_object(other)/other.blastRadius)) * vectorfactor);
    } 
}

ownerPlayer.dispenser = noone;
instance_create(x,y,Explosion);
playsound(x,y,ExplosionSnd);
sentrygibs=instance_create(x,y,SentryGibs);
sentrygibs.sprite_index = DispenserGibsS;
sentrygibs.image_speed = 0;
if (team == TEAM_RED)
    sentrygibs.image_index = 0;
else
    sentrygibs.image_index = 1;
')

object_event_add(TeleporterEntrance,ev_create,0,'
	image_speed = 0;
	vspeed = .001;
	oldVspeed = .001;
	maxHp = 75;
	hp = 15;
	built = 0;
	image_speed = 0;
	landed = 0;
	humiliated = 0;
	buildrate = 1.6;
	buildingtype = 2;
	charge = 100;
	ubered = 0;

	// For self-knockback when destroyed
	blastRadius = 65;
	knockback = 4;
		   
	lastDamageDealer = noone;
	lastDamageSource = -1;
')
object_event_add(TeleporterEntrance,ev_step,ev_step_begin,'
if !instance_exists(ownerPlayer) {
    instance_destroy();
	exit;
}
if(global.isHost and (ownerPlayer.class != CLASS_ENGINEER or team != ownerPlayer.team or collision_circle(x,y+10,25,Sentry,false,true)>=0 or collision_circle(x,y+10,25,Dispenser,false,true)>=0 or collision_circle(x,y+10,25,TeleporterEntrance,false,true)>=0 or collision_circle(x,y+10,25,TeleporterExit,false,true)>=0))
{
    execute_file(sendEventBuildingDestruction, ownerPlayer, noone, noone, -1, buildingtype);
	execute_file(doEventBuildingDestruction, ownerPlayer, noone, noone, -1, buildingtype);
    exit;
}

if (built == 0 and vspeed == 0)
{
    if (hp < maxHp)
        hp += buildrate * global.delta_factor;
    else
        built = 1;
    buildrate = min(buildrate, buildrate+(0.4*global.delta_factor/45));
	
    if !built image_index = floor(hp/maxHp*18);
	
    if (landed == 0)
    {
        landed = 1;
        playsound(x,y,SentryFloorSnd);
        playsound(x,y,SentryBuildSnd);
    } 
}
	if !humiliated && built && instance_exists(ownerPlayer.texit) {
		if ownerPlayer.texit.built {
			image_index += charge * global.delta_factor /100;
			if charge < 100 charge += 1 * global.delta_factor;
			else charge = 100;
		}
	}
	if !humiliated && built && vspeed <= 0 {
		while image_index > 29 image_index -= 11;
		while image_index < 18 image_index += 18;
		
		if (team == TEAM_BLUE)
        sprite_index = TeleporterEntranceBlueS;
		if (team == TEAM_RED)
        sprite_index = TeleporterEntranceRedS;
	}
if (humiliated == 1 and built == 1 )
    event_user(1);
    
wallSetSolid();

// Try to get outside of the wallmask if we are in it.
if(!place_free(x, y))
    move_outside_solid(0, 6);
if(!place_free(x, y))
    move_outside_solid(180, 12);
if(!place_free(x, y))
{
    move_outside_solid(0, 6);
    move_outside_solid(90, 100);
}

if(place_free(x+hspeed, y+vspeed+0.6))
    vspeed += 0.6  * global.delta_factor;
if(!place_free(x+hspeed, y+vspeed) and place_free(x, y))
    event_user(2);

if(vspeed > 10)
    vspeed = 10;

wallUnsetSolid();

if(oldVspeed != 0 and vspeed == 0 and global.isHost)
{
	var sendBuffer;
	sendBuffer = buffer_create();
	write_ubyte(sendBuffer, buildings.building_position);
	write_ubyte(sendBuffer,buildingtype)
    write_ubyte(sendBuffer, ds_list_find_index(global.players, ownerPlayer));
    write_ushort(sendBuffer, round(x*5));
    write_ushort(sendBuffer, round(y*5));
	PluginPacketSend(buildings.packetID,sendBuffer);
}

oldVspeed = vspeed;

x += hspeed * global.delta_factor;
y += vspeed * global.delta_factor;
x -= hspeed;
y -= vspeed;

')
object_event_add(TeleporterEntrance,ev_step,ev_step_normal,'
var me;
me = id;
with Character {
	if !(collision_circle(x, y, 20, me, false, true) < 0) {
		if me.team = team {
				teleporter = me;
		}
	}
}
')
object_event_add(TeleporterEntrance,ev_step,ev_step_end,'
if !instance_exists(ownerPlayer) {
    instance_destroy();
	exit;
}
	if(global.isHost and hp<=0)
	{
		var healer;
		healer = noone;
		with(lastDamageDealer)
			if (object)
				if (object.healer)
					healer = object.healer;
					
		execute_file(sendEventBuildingDestruction, ownerPlayer, lastDamageDealer, healer, lastDamageSource, buildingtype);
	    execute_file(doEventBuildingDestruction, ownerPlayer, lastDamageDealer, healer, lastDamageSource, buildingtype);
		exit;
	}
	if(hp>maxHp) hp=maxHp;
')
object_event_add(TeleporterEntrance,ev_collision,KillBox,'
hp -= 999;
lastDamageDealer = noone;
')
object_event_add(TeleporterEntrance,ev_collision,FragBox,'
hp -= 999;
lastDamageDealer = noone;
')
object_event_add(TeleporterEntrance,ev_collision,IntelGate,'
hp -= 999;
lastDamageDealer = noone;
')
object_event_add(TeleporterEntrance,ev_other,ev_user2,'
{
    wallSetSolid();
    really_move_contact_solid(direction, speed);
    if(!place_free(x, y+1))
        vspeed = 0;
    wallUnsetSolid();
}
')
object_event_add(TeleporterEntrance,ev_draw,0,'
if !instance_exists(ownerPlayer) exit;
if(vspeed > 0)
{
    var chuteIndex;
    chuteIndex = ceil(vspeed/10*3)-1;
    image_index = chuteIndex + (team==TEAM_BLUE)*3;
    sprite_index = ParachuteSentry;
}
else
{
    if (team == TEAM_BLUE)
        sprite_index = TeleporterEntranceBlueS;
    if (team == TEAM_RED)
        sprite_index = TeleporterEntranceRedS;
}
xr = round(x);
yr = round(y);
if global.myself.team == team draw_healthbar(xr-10, yr-30, xr+10, yr-25,hp*100/maxHp,c_black,c_red,c_green,0,true,true);
if (built && hp < .75 * maxHp) draw_sprite_part_ext(FlameS, random(4), 0, 0, 21, 9, xr-21/2, yr-10, 1, 1, c_white, 1 - (hp / maxHp));
draw_sprite_ext(sprite_index,image_index,xr,yr,image_xscale,image_yscale,image_angle,c_white,1);

if(distance_to_point(mouse_x, mouse_y)<25 && global.myself.team == team) {
    draw_set_alpha(1);   
    draw_set_halign(fa_center);
    draw_set_valign(fa_bottom); 
    if(team==TEAM_RED) {
        draw_set_color(c_red);
    } else {
        draw_set_color(c_blue);
    }
    draw_text(xr, yr-45, ownerPlayer.name + possessive);
    draw_text(xr, yr-35, "Transporter Entrance");
	if instance_exists(ownerPlayer.texit) {
		if instance_exists(global.myself.object)  {
			if !global.myself.object.intel {
			    if (global.myself.object.teleporter = id && charge = 100) draw_text(xr, yr-25, "Press " + chr(global.down) + " to use!");
			    else draw_text(xr, yr-25, "Charge: " + string(charge) + "%");
			} else draw_text(xr, yr-25, "Cannot teleport while carrying the intelligence!");
		} else draw_text(xr, yr-25, "Charge: " + string(charge) + "%");
	} else draw_text(xr, yr-25, "No exit built!");
}
')
object_event_add(TeleporterEntrance,ev_destroy,0,'
if !instance_exists(ownerPlayer) exit;
if (global.myself == ownerPlayer)
{
    if !instance_exists(NoticeO) instance_create(0,0,NoticeO);
    with NoticeO {
	notice = NOTICE_CUSTOM;
	message = "Transporter Entrance scrapped!";
	}
}

// Allow the mines stickied to this autogun to drop to the floor
with(Mine)
{
    if(place_meeting(x,y,other.id))
        stickied = false;
}

// Knock back our owner
with(ownerPlayer.object)
{
    if (distance_to_object(other) < other.blastRadius
        and !place_meeting(x, y+1, Obstacle))
    {
        var rdir, vectorfactor;
        rdir = point_direction(other.x, other.y, (bbox_left+bbox_right)/2, (bbox_top+bbox_bottom)/2);
        vectorfactor = point_distance(0, 0, power(sin(degtorad(rdir)), 2), power(cos(degtorad(rdir)), 2));
        if (1 - distance_to_object(other)/other.blastRadius <= 0.25)
            continue;
        motion_add(rdir, min(15, other.knockback-other.knockback*(distance_to_object(other)/other.blastRadius)) * vectorfactor);
    } 
}

ownerPlayer.tentrance = noone;
instance_create(x,y,Explosion);
playsound(x,y,ExplosionSnd);
sentrygibs=instance_create(x,y,SentryGibs);
sentrygibs.sprite_index = TeleporterGibsS;
sentrygibs.image_speed = 0;
sentrygibs.power = 0.5;
if (team == TEAM_RED)
    sentrygibs.image_index = 0;
else
    sentrygibs.image_index = 1;
')
object_event_add(TeleporterExit,ev_create,0,'
	image_speed = 0;
	vspeed = .001;
	oldVspeed = .001;
	maxHp = 75;
	hp = 15;
	built=0;
	image_speed = 0;
	landed=0;
	humiliated = 0;
	buildrate = 1.6;
	buildingtype = 3;
	charge = 0;
	ubered = 0;

	// For self-knockback when destroyed
	blastRadius = 65;
	knockback = 4;
		   
	lastDamageDealer = noone;
	lastDamageSource = -1;
')
object_event_add(TeleporterExit,ev_step,ev_step_begin,'
if !instance_exists(ownerPlayer) {
    instance_destroy();
	exit;
}
if(global.isHost and (ownerPlayer.class != CLASS_ENGINEER or team != ownerPlayer.team or collision_circle(x,y+10,25,Sentry,false,true)>=0 or collision_circle(x,y+10,25,Dispenser,false,true)>=0 or collision_circle(x,y+10,25,TeleporterEntrance,false,true)>=0 or collision_circle(x,y+10,25,TeleporterExit,false,true)>=0))
{
    execute_file(sendEventBuildingDestruction, ownerPlayer, noone, noone, -1, buildingtype);
	execute_file(doEventBuildingDestruction, ownerPlayer, noone, noone, -1, buildingtype);
    exit;
}

if (built == 0 and vspeed == 0)
{
    if (hp < maxHp)
        hp += buildrate * global.delta_factor;
    else
        built = 1;
    buildrate = min(buildrate, buildrate+(0.4*global.delta_factor/45));
	
    if !built image_index = floor(hp/maxHp*18);
	
    if (landed == 0)
    {
        landed = 1;
        playsound(x,y,SentryFloorSnd);
        playsound(x,y,SentryBuildSnd);
    } 	
}
	if !humiliated && built && instance_exists(ownerPlayer.tentrance){
		if ownerPlayer.tentrance.built image_index += 0.5 * global.delta_factor;
	}
	if !humiliated && built && vspeed <= 0 {
		while image_index > 29 image_index -= 11;
		while image_index < 18 image_index += 18;
		
		if (team == TEAM_BLUE)
        sprite_index = TeleporterExitBlueS;
		if (team == TEAM_RED)
        sprite_index = TeleporterExitRedS;
	}
		
wallSetSolid();

// Try to get outside of the wallmask if we are in it.
if(!place_free(x, y))
    move_outside_solid(0, 6);
if(!place_free(x, y))
    move_outside_solid(180, 12);
if(!place_free(x, y))
{
    move_outside_solid(0, 6);
    move_outside_solid(90, 100);
}

if(place_free(x+hspeed, y+vspeed+0.6))
    vspeed += 0.6  * global.delta_factor;
if(!place_free(x+hspeed, y+vspeed) and place_free(x, y))
    event_user(2);

if(vspeed > 10)
    vspeed = 10;

wallUnsetSolid();

if(oldVspeed != 0 and vspeed == 0 and global.isHost)
{
	var sendBuffer;
	sendBuffer = buffer_create();
	write_ubyte(sendBuffer, buildings.building_position);
	write_ubyte(sendBuffer,buildingtype)
    write_ubyte(sendBuffer, ds_list_find_index(global.players, ownerPlayer));
    write_ushort(sendBuffer, round(x*5));
    write_ushort(sendBuffer, round(y*5));
	PluginPacketSend(buildings.packetID,sendBuffer);
}

oldVspeed = vspeed;

x += hspeed * global.delta_factor;
y += vspeed * global.delta_factor;
x -= hspeed;
y -= vspeed;

')
object_event_add(TeleporterExit,ev_step,ev_step_end,'
if !instance_exists(ownerPlayer) {
    instance_destroy();
	exit;
}
	if(global.isHost and hp<=0)
	{
		var healer;
		healer = noone;
		with(lastDamageDealer)
			if (object)
				if (object.healer)
					healer = object.healer;
					
		execute_file(sendEventBuildingDestruction, ownerPlayer, lastDamageDealer, healer, lastDamageSource, buildingtype);
	    execute_file(doEventBuildingDestruction, ownerPlayer, lastDamageDealer, healer, lastDamageSource, buildingtype);
		exit;
	}
	if(hp>maxHp) hp=maxHp;
')
object_event_add(TeleporterExit,ev_collision,KillBox,'
hp -= 999;
lastDamageDealer = noone;
')
object_event_add(TeleporterExit,ev_collision,FragBox,'
hp -= 999;
lastDamageDealer = noone;
')
object_event_add(TeleporterExit,ev_collision,IntelGate,'
hp -= 999;
lastDamageDealer = noone;
')
object_event_add(TeleporterExit,ev_other,ev_user1,'
    humiliated = 1;
')
object_event_add(TeleporterExit,ev_other,ev_user2,'
{
    wallSetSolid();
    really_move_contact_solid(direction, speed);
    if(!place_free(x, y+1))
        vspeed = 0;
    wallUnsetSolid();
}
')
object_event_add(TeleporterExit,ev_draw,0,'
if !instance_exists(ownerPlayer) exit;
if(vspeed > 0)
{
    var chuteIndex;
    chuteIndex = ceil(vspeed/10*3)-1;
    image_index = chuteIndex + (team==TEAM_BLUE)*3;
    sprite_index = ParachuteSentry;
}
else
{
    if (team == TEAM_BLUE)
        sprite_index = TeleporterExitBlueS;
    if (team == TEAM_RED)
        sprite_index = TeleporterExitRedS;
}
xr = round(x);
yr = round(y);
if global.myself.team == team draw_healthbar(xr-10, yr-30, xr+10, yr-25,hp*100/maxHp,c_black,c_red,c_green,0,true,true);
if (built && hp < .75 * maxHp) draw_sprite_part_ext(FlameS, random(4), 0, 0, 21, 9, xr-21/2, yr-10, 1, 1, c_white, 1 - (hp / maxHp));
draw_sprite_ext(sprite_index,image_index,xr,yr,image_xscale,image_yscale,image_angle,c_white,1);

if(distance_to_point(mouse_x, mouse_y)<25 && global.myself.team == team) {
    draw_set_alpha(1);   
    draw_set_halign(fa_center);
    draw_set_valign(fa_bottom); 
    if(team==TEAM_RED) {
        draw_set_color(c_red);
    } else {
        draw_set_color(c_blue);
    }
    draw_text(xr, yr-45, ownerPlayer.name + possessive);
    draw_text(xr, yr-35, "Transporter Exit");
	if !instance_exists(ownerPlayer.tentrance) draw_text(xr, yr-25, "No entrance built!");
}
')
object_event_add(TeleporterExit,ev_destroy,0,'
if !instance_exists(ownerPlayer) exit;
if (global.myself == ownerPlayer)
{
    if !instance_exists(NoticeO) instance_create(0,0,NoticeO);
    with NoticeO {
	notice = NOTICE_CUSTOM;
	message = "Transporter Exit scrapped!";
	}
}

// Allow the mines stickied to this autogun to drop to the floor
with(Mine)
{
    if(place_meeting(x,y,other.id))
        stickied = false;
}

// Knock back our owner
with(ownerPlayer.object)
{
    if (distance_to_object(other) < other.blastRadius
        and !place_meeting(x, y+1, Obstacle))
    {
        var rdir, vectorfactor;
        rdir = point_direction(other.x, other.y, (bbox_left+bbox_right)/2, (bbox_top+bbox_bottom)/2);
        vectorfactor = point_distance(0, 0, power(sin(degtorad(rdir)), 2), power(cos(degtorad(rdir)), 2));
        if (1 - distance_to_object(other)/other.blastRadius <= 0.25)
            continue;
        motion_add(rdir, min(15, other.knockback-other.knockback*(distance_to_object(other)/other.blastRadius)) * vectorfactor);
    } 
}

ownerPlayer.texit = noone;
instance_create(x,y,Explosion);
playsound(x,y,ExplosionSnd);
sentrygibs=instance_create(x,y,SentryGibs);
sentrygibs.sprite_index = TeleporterGibsS;
sentrygibs.image_speed = 0;
sentrygibs.power = 0.5;
if (team == TEAM_RED)
    sentrygibs.image_index = 0;
else
    sentrygibs.image_index = 1;
')
