//Mo' buildings mod. Cause dispensers and teleporters are fun to work with.
//2015 BassMakesPaste
//Initiation
if (isServerSentPlugin != 1) exit;
globalvar buildings;
buildings = id;

//Spriteloading
var spriteDirectory, ext;
globalvar inputSpecialx, DispenserBlueS, DispenserRedS, TeleporterEntranceRedS, TeleporterEntranceBlueS, TeleporterExitRedS, TeleporterExitBlueS, DispenserGibsS, TeleporterGibsS, BuildMenuS, BuildingHUDS;
ext =".gmspr"
spriteDirectory = directory + "\Sprites\";
if file_exists(spriteDirectory+"DispenserRedS"+ext)
    DispenserRedS=sprite_add_sprite(spriteDirectory+"DispenserRedS"+ext);
else {
	show_message("File not found: DispenserRedS"+ext);
	exit;
}
if file_exists(spriteDirectory+"DispenserBlueS"+ext)
    DispenserBlueS=sprite_add_sprite(spriteDirectory+"DispenserBlueS"+ext);
else {
	show_message("File not found: DispenserBlueS"+ext);
	exit;
}
if file_exists(spriteDirectory+"DispenserGibsS"+ext)
    DispenserGibsS=sprite_add_sprite(spriteDirectory+"DispenserGibsS"+ext);
else {
	show_message("File not found: DispenserGibS"+ext);
	exit;
}
if file_exists(spriteDirectory+"TeleporterEntranceRedS"+ext)
    TeleporterEntranceRedS=sprite_add_sprite(spriteDirectory+"TeleporterEntranceRedS"+ext);
else {
	show_message("File not found: TeleporterEntranceRedS"+ext);
	exit;
}
if file_exists(spriteDirectory+"TeleporterEntranceBlueS"+ext)
    TeleporterEntranceBlueS=sprite_add_sprite(spriteDirectory+"TeleporterEntranceBlueS"+ext);
else {
	show_message("File not found: TeleporterEntranceBlueS"+ext);
	exit;
}
if file_exists(spriteDirectory+"TeleporterExitRedS"+ext)
    TeleporterExitRedS=sprite_add_sprite(spriteDirectory+"TeleporterExitRedS"+ext);
else {
	show_message("File not found: TeleporterExitRedS"+ext);
	exit;
}
if file_exists(spriteDirectory+"TeleporterExitBlueS"+ext)
    TeleporterExitBlueS=sprite_add_sprite(spriteDirectory+"TeleporterExitBlueS"+ext);
else {
	show_message("File not found: TeleporterExitBlueS"+ext);
	exit;
}
if file_exists(spriteDirectory+"TeleporterGibsS"+ext)
    TeleporterGibsS=sprite_add_sprite(spriteDirectory+"TeleporterGibsS"+ext);
else {
	show_message("File not found: TeleporterGibsS"+ext);
	exit;
}
if file_exists(spriteDirectory+"BuildMenuS"+ext)
    BuildMenuS=sprite_add_sprite(spriteDirectory+"BuildMenuS"+ext);
else {
	show_message("File not found: BuildMenuS"+ext);
	exit;
}
if file_exists(spriteDirectory+"BuildingHUDS"+ext)
    BuildingHUDS=sprite_add_sprite(spriteDirectory+"BuildingHUDS"+ext);
else {
	show_message("File not found: BuildingHUDS"+ext);
	exit;
}

//Packet states
request = 253;
building_position = 254;
building_destruction = 255;

//Create objects used by plugin and assign their appropriate sprites.
globalvar Dispenser, TeleporterEntrance, TeleporterExit, BuildMenu, BuildingHUD;
object_set_depth(Sentry,1);
Dispenser = object_add();
object_set_sprite(Dispenser,DispenserRedS);
object_set_depth(Dispenser,1);
TeleporterEntrance = object_add();
object_set_sprite(TeleporterEntrance,TeleporterEntranceRedS);
object_set_depth(TeleporterEntrance,1);
TeleporterExit = object_add();
object_set_sprite(TeleporterExit,TeleporterExitRedS);
object_set_depth(TeleporterExit,1);

BuildMenu = object_add();
object_set_depth(BuildMenu,-110000);

//BuildingHUD = object_add();
//object_set_depth(BuildingHUD,-110000);
//object_set_sprite(BuildingHUD,BuildingHUDS);
object_set_sprite(SentryHealthHud,BuildingHUDS);

globalvar BlindingFlash;
BlindingFlash = object_add();
object_set_depth(BlindingFlash,-109999);

//Run scripts to add things to objects.
if file_exists(directory + "\Objects.gml") execute_file(directory + "\Objects.gml");
else {
    show_message("File not found: Objects.gml");
    exit;
}

if file_exists(directory + "\Networking.gml") execute_file(directory + "\Networking.gml");
else {
    show_message("File not found: Networking.gml");
    exit;
}

if file_exists(directory + "\Damage.gml") execute_file(directory + "\Damage.gml");
else {
    show_message("File not found: Damage.gml");
    exit;
}

//Load up all of the script directories so I can be lazy and call them like this.
globalvar buildBuilding, recordBuildingDestructionInLog, doEventBuildingDestruction, sendEventBuildingDestruction, damageAutoBetter;

if file_exists(directory + "\Scripts\buildBuilding.gml") buildBuilding = directory + "\Scripts\buildBuilding.gml";
else {
    show_message("File not found: buildBuilding.gml");
    exit;
}
if file_exists(directory + "\Scripts\recordBuildingDestructionInLog.gml") recordBuildingDestructionInLog = directory + "\Scripts\recordBuildingDestructionInLog.gml";
else {
    show_message("File not found: recordBuildingDestructionInLog.gml");
    exit;
}
if file_exists(directory + "\Scripts\doEventBuildingDestruction.gml") doEventBuildingDestruction = directory + "\Scripts\doEventBuildingDestruction.gml";
else {
    show_message("File not found: doEventBuildingDestruction.gml");
    exit;
}
if file_exists(directory + "\Scripts\sendEventBuildingDestruction.gml") sendEventBuildingDestruction = directory + "\Scripts\sendEventBuildingDestruction.gml";
else {
    show_message("File not found: sendEventBuildingDestruction.gml");
    exit;
}
if file_exists(directory + "\Scripts\damageAutoBetter.gml") damageAutoBetter = directory + "\Scripts\damageAutoBetter.gml";
else {
    show_message("File not found: damageAutoBetter.gml");
    exit;
}

inputSpecialx = '
if(global.myself.class == CLASS_ENGINEER){
    if !instance_exists(BuildMenu) instance_create(0,0,BuildMenu);
} else if global.myself.object.taunting==false && global.myself.object.omnomnomnom==false && global.myself.class==CLASS_HEAVY {
    write_ubyte(global.serverSocket, OMNOMNOMNOM);
} else if global.myself.class == CLASS_SNIPER {
    write_ubyte(global.serverSocket, TOGGLE_ZOOM);
}'